=== modified file 'mandos'
--- mandos	2010-08-24 18:18:01 +0000
+++ mandos	2010-09-02 18:36:36 +0000
@@ -332,7 +332,7 @@
         self.approved_duration = string_to_delta(
             config[u"approved_duration"])
         self.changedstate = multiprocessing_manager.Condition(multiprocessing_manager.Lock())
-
+    
     def send_changedstate(self):
         self.changedstate.acquire()
         self.changedstate.notify_all()
@@ -702,6 +702,7 @@
     # dbus.service.Object doesn't use super(), so we can't either.
     
     def __init__(self, bus = None, *args, **kwargs):
+        self._approvals_pending = 0
         self.bus = bus
         Client.__init__(self, *args, **kwargs)
         # Only now, when this client is initialized, can it show up on
@@ -712,6 +713,21 @@
         DBusObjectWithProperties.__init__(self, self.bus,
                                           self.dbus_object_path)
     
+    def _get_approvals_pending(value):
+        return self._approvals_pending
+    def _set_approvals_pending(value):
+        old_value = self._approvals_pending
+        self._approvals_pending = value
+        bval = bool(value)
+        if bval is bool(old_value):
+            dbus_bool = dbus.Boolean(bval, variant_level=1)
+            self.PropertyChanged(dbus.String(u"approved_pending"),
+                                 dbus_bool)
+        return value
+    approvals_pending = property(_get_approvals_pending,
+                                 _set_approvals_pending)
+    del _get_approvals_pending, _set_approvals_pending
+    
     @staticmethod
     def _datetime_to_dbus(dt, variant_level=0):
         """Convert a UTC datetime.datetime() to a D-Bus type."""
@@ -813,9 +829,6 @@
     def approve(self, value=True):
         self._approved = value
         gobject.timeout_add(self._timedelta_to_milliseconds(self.approved_duration, self._reset_approved))
-
-    def approved_pending(self):
-        return self.approvals_pending > 0
     
     
     ## D-Bus methods, signals & properties
@@ -845,25 +858,19 @@
     @dbus.service.signal(_interface)
     def GotSecret(self):
         "D-Bus signal"
-        if self.approved_pending():
-            self.PropertyChanged(dbus.String(u"checker_running"),
-                                 dbus.Boolean(False, variant_level=1))
+        pass
     
     # Rejected - signal
     @dbus.service.signal(_interface, signature=u"s")
     def Rejected(self, reason):
         "D-Bus signal"
-        if self.approved_pending():
-            self.PropertyChanged(dbus.String(u"checker_running"),
-                                 dbus.Boolean(False, variant_level=1))
+        pass
     
     # NeedApproval - signal
     @dbus.service.signal(_interface, signature=u"db")
     def NeedApproval(self, timeout, default):
         "D-Bus signal"
-        if not self.approved_pending():
-            self.PropertyChanged(dbus.String(u"approved_pending"),
-                                 dbus.Boolean(True, variant_level=1))
+        pass
     
     ## Methods
 
@@ -905,7 +912,7 @@
     # approved_pending - property
     @dbus_service_property(_interface, signature=u"b", access=u"read")
     def approved_pending_dbus_property(self):
-        return dbus.Boolean(self.approved_pending())
+        return dbus.Boolean(bool(self.approvals_pending))
     
     # approved_by_default - property
     @dbus_service_property(_interface, signature=u"b",
@@ -1491,12 +1498,12 @@
                 parent_pipe.send(('function',))
             else:
                 parent_pipe.send(('data', client_object.__getattribute__(attrname)))
-
+        
         if command == 'setattr':
             attrname = request[1]
             value = request[2]
             setattr(client_object, attrname, value)
-            
+        
         return True
 
 

